################################################################################
################################################################################
################################################################################

''' ATTENZIONE!!! INSERITE QUI SOTTO IL VOSTRO NOME, COGNOME E MATRICOLA '''

nome        = "giacomo"
cognome     = "venanzi"
matricola   = "1784507"

################################################################################
################################################################################
################################################################################


'''
    Es 2: 5 punti
    Si definisca la funzione es2(tree ) ricorsiva (o che fa uso di funzioni o
    metodi ricorsive/i) che:
    - riceve come argomenti  l'albero 'tree'  formato da nodi di tipo
      Nodo definito nella libreria albero.py allegata
    - torna come risultato il nodo radice dell'albero che si ottiene da tree
    eliminando i suoi nodi foglia con identificatore di valore pari.

    Esempio: con input l'albero in basso a sinistra la funzione deve restituire
    la radice dell'albero in basso a destra

              5                                    5
      ________|_____________               ________|_
     |          |           |             |          |
     20         4           6             20         4
     |     _____|______                           ___|___
     12   |   |  |  |  |                         |   |   |
          10  2  9  8  7                         2   9   7
            __|__
           |     |
           30    22

    NOTA: perchè il test di ricorsione abbia successo la funzione ricorsiva deve essere
    definita a livello globale o essere un metodo di una classe definita a livello globale.
'''
import albero

def es2(tree):
    # inserisci qui il tuo codice
    #devo iterare l'albero fino alle foglie poi se questa ha id pari la elimino
    #itero i figli di ogni dir se i-esimo nodo è una foglia lo elimino
    for i in range(len(tree.f)-1, -1,-1):
        #controllo la lista dei figli del nodo figlio
        if len(tree.f[i].f) == 0:
            #il nodo figlio non ha figli quindi è una foglia
            #ora se la foglia ha id pari la elimino
            if (tree.f[i].id % 2) == 0:  
                tree.f.pop(i)
        else:
            #allora è una dir quindi richiamo la funzione
            es2(tree.f[i])
    return tree

##########################################################################################


'''
    Es 4: 4 punti
progettare la funzione es4(ftesto) che, preso in input l'indirizzo di un file di
testo ftesto,restituisce la tripla (x,y,p1,p2) dove:
- 1) x e' il numero di righe del file di testo
- 2) y il numero di righe del file di testo contenenti un numero dispari di parole
- 3) p1 e' la parola di lungehzza massima tra le parole presenti nel file
     (in caso di parita' di lunghezza massima va considerata quella che precede
     le altre in ordine lessicografico)
- 4) p2 e' la parola che appare piu' volte  tra le parole presenti nel file (in caso
  di parita' di frequenza  massima va considerata quella che precede
  le altre in ordine lessicografico)

Esempio: la funzione sul file di testo ft1.txt deve restituire
la quadrupla (4, 2, 'elefante', 'gatto')
'''

#restituisce la quadrupla => una tupla
def es4(ftesto):
    # inserisci qui il tuo codice
    x = 0
    y = 0
    p1 = ''
    p2 = ''
    #mi tengo un dizionario per la frequenza delle parole
    words_dict = {}
    #apro il file
    with open(ftesto) as f:
        text = f.readlines()
    
    #text contiene una lista di righe
    x = len(text)#numero totale di righe
    #itero le righe del testo
    for line in text:
        line_words = [ w for w in line.split('\n')]
        line_words = [w for w in line_words[0].split(' ') if w != '']       
        #controllo se la linea ha numero di parole dispari se è così aggiorno y
        if (len(line_words) % 2) == 1:
            y += 1
        #ora devo iterare le parole e inserirle nel dizionario
        for word in line_words:
            #controllo se è più lunga della parola massima nel caso aggiorno p1
            if len(p1) < len(word):
                p1 = word
            elif len(p1) == len(word):
                p1 = min([p1, word])
            #aggiorno il dizionario
            if word in words_dict.keys():
                words_dict[word] += 1
            else:
                words_dict[word] = 1
    #dal dizionario creato prendo la parola più presente
    p2 = min(words_dict, key= lambda x: (-words_dict[x], x))
    return (x,y,p1,p2)



###############################################################################################


'''
    Es 7: 5 punti
    Si definisca la funzione es7(pathDir ) ricorsiva (o che fa uso di funzioni o
    metodi ricorsive/i) che:
    - riceve come argomento l'indirizzo di una cartella.
    - restituisce una lista contenente triple. Le triple sono del tipo (S,a,b) dove:
      - S e' il nome di una delle sottocartelle ragiungibili a qualsiasi livello visitando
        l'albero delle cartelle radicato nella cartella.
      - a e'  il  numero totale di file  presenti nella cartella S e nelle sue
        sottocartelle.
      - b e' il numero totale di  sottocartelle  presenti nella cartella
      S e nelle sue sottocartelle.
      Le tuple nella lista devono risultare ordinate in modo decrescente rispetto
      alla somma della seconda e terza componente e a parita' di somma
      in ordine lessicografico crescente rispetto alla prima coordinata.
      ATTENZIONE: File e cartelle il cui nome comincia  col carattere '.'
      non vanno considerati.

      ai fini dello svolgimento dell'esercizio possono risultare utili
      le seguenti funzioni nel modulo os:
      os.listdir(), os.path.isfile(), os.path.isdir(), os.path.basename().

      ATTENZIONE: è PROIBITO usare la funzione os.walk()

    Esempio: con es7('Informatica/Software') viene restituita la lista:
    [('Software', 7, 2), ('SistemiOperativi', 5, 0),('BasiDati', 0, 0)]

    NOTA: perchè il test di ricorsione abbia successo la funzione ricorsiva deve essere
    definita a livello globale o essere un metodo di una classe definita a livello globale.
'''

import os

def es7(pathDir):
    # inserisci qui il tuo codice
    lista_triple = get_triple(pathDir)
    return sorted(lista_triple,  key= lambda x: (-(x[1] + x[2]), x[0]))

def get_triple(pathDir):
    lista_out = []
    #controllo la cartella corrente
    lista_out.append((os.path.basename(pathDir), get_all_files(pathDir),get_all_dir(pathDir)))
    for son in os.listdir(pathDir):
        if son.startswith('.'):
            continue
        if os.path.isfile(os.path.join(pathDir, son)):
            continue
        lista_out += get_triple(os.path.join(pathDir,son))
    return lista_out
    
def get_all_files(directory):
    #so che questa è solo una directory
    count =0
    for son in os.listdir(directory):
        if son.startswith('.'):
            continue
        if os.path.isfile(os.path.join(directory, son)):
            count += 1
        else:
            count += get_all_files(os.path.join(directory, son))
    return count

def get_all_dir(directory):
    #so che questa è solo una directory
    count =0
    for son in os.listdir(directory):
        if son.startswith('.'):
            continue
        if os.path.isdir(os.path.join(directory, son)):
            count += 1
            count += get_all_dir(os.path.join(directory, son))
        
    return count
    

###############################################################################################


'''
    Es 13: 5 punti
    Progettare la  funzione es13(fimm,fimm1) che,
    - riceve gli  indirizzi fimm e  fimm1 di due file .PNG.
    - legge l'immagine da fimm ne modifica i colori dei pixel e  la salva poi
      all'indirizzo fimm1.
    - restituisce infine il numero di colori DIFFERENTI presenti nell'immagine modificata.
      Altezza e larghezza della nuova immagine sono le stesse dell'immagine originale.
      I colori dei pixel dalla nuova immagine si ottengono a partire da quelli
      dell'immagine originale applicando la seguente  procedura:
      La griglia dei pixel dell'immagine originale viene partizionata  in sottogriglie
      quadrate ciacuna di dimensione 9 per 9.
      Si puo' assumere che la lunghezza w e l' altezza h dell'immagine sono multipli di 9
      pertanto si avranno h//9 x w//9 sottogriglie.
      Nella nuova immagine il pixel posizionato al
      centro di ciascuna delle sottogriglie conservera' lo stesso colore del pixel
      corrispondente nella foto originaria. Gli altri 80 pixel della sottogriglia
      avranno tutti uno stesso colore.
      Questo colore si ottiene facendo la media intera  dei colori degli 80
      pixel corrispodenti nella foto originaria. Il colore sara' dunque (r,g,b) dove
      -r e' la parte intera della divisione per 80 della  somma
       degli 80 valori del primo canale dei colori degli 80 pixel,
      -g e' la parte intera della divisione per 80 della  somma
       degli 80 valori del secndo canale dei colori deegli 80 pixel,
      -b e' la parte intera della divisione per 80 della  somma
       degli 80 valori del terzo canale dei colori degli 80 pixel,

    Sull'immagine Fig1.png la funzione deve produrre il file RisFig1.png
    e restituire il numero 1379

    Per caricare e salvare i file PNG si possono usare load e save della libreria immagini.
'''

import immagini

def es13(fimm,fimm1):
    # inserisci qui il tuo codice
    #prendo l'immagine
    img = immagini.load(fimm)
    #i colori che inserisco di volta in volta nell'immagine modificata
    new_colors = set()
    for y in range(len(img)//9):
        for x in range(len(img[0])//9):
            mid_color = get_media_colors(img, x*9, y*9)
            new_colors.add(mid_color)
            #così ho x e y del quadretto ora devo colorare 80 pixel
            for i in range(y*9,(y*9)+9):
                for j in range(x*9,(x*9)+9):
                    if i == (y*9)+4 and j == (x*9)+4:
                        new_colors.add(img[i][j])
                        #sono nel colore di mezzo e metto lo stesso
                        continue
                    img[i][j] = mid_color
                    
    #devo salvare l'immagine
    immagini.save(img, fimm1)
    return len(new_colors)

def get_media_colors(matrix, x, y):
    r = 0
    g = 0
    b = 0
    for i in range(y, y+9):
        for j in range(x, x+9):
            if i == (y+4) and j == (x+4):
                continue
            r += matrix[i][j][0]
            g += matrix[i][j][1]
            b += matrix[i][j][2]
    return (r//80, g//80, b//80)

 ########################################################################################


'''
    Es 14: 3 punti
    Abbiamo una tabella rappresentata come lista di dizionari    nome_colonna : valore .
    ed una lista contenente i nomi di alcune delle colonne della tabella.
    Vogliamo costruire una nuova tabella  eliminando dalla tabella originaria le colonne i
    cui nomi sono presenti nella lista. Nella nuova tabella in caso di righe uguali
    va conservata solo la prima di queste righe mentre le altre vanno eliminate.
    Si consideri ad esempio la tabella con tre colonne ('nome', 'materia', 'voto')

    | 'nome'  | 'materia'        | 'voto' |
    --------------------------------------
    |'Franco' | 'programmazione' |   30   |
    |'Franco' | 'architettura'   |   30   |
    |'Franco' | 'algoritmi'      |   25   |
    |'Franco' | 'matematica'     |   20   |
    |'Angelo' | 'programmazione' |   30   |
    |'Angelo' | 'architettura'   |   30   |
    |'Angelo' | 'algoritmi'      |   30   |
    |'Lucia'  | 'architettura'   |   30   |
    |'Lucia'  | 'algoritmi'      |   25   |
    |'Lucia'  | 'algebra'        |   18   |
    |'Lucia'  | 'programmazione' |   27   |
    |'Lucia ' | 'matematica'     |   21   |

se la lista coi nomi delle colonne da eliminare contiene 'nome' allora la nuova tabella e':

 | 'materia'        | 'voto' |
 --------------------------------------
 | 'programmazione' |   30   |
 | 'architettura'   |   30   |
 | 'algoritmi'      |   25   |
 | 'matematica'     |   20   |
 | 'algoritmi'      |   30   |
 | 'algebra'        |   18   |
 | 'programmazione' |   27   |
 | 'matematica'     |   21   |


Progettare la  funzione es14(fileJson,insCol,fileJson1) che riceve in input gli  indirizzi
fileJsonIn e  filejsonOut di due file di tipo json ed un  insieme  di stringhe insCol.
Il file fileJsonIn contine una tabella (memorizzata come lista di dizionari) e l'insieme
insCol contiene i nomi di alcune colonne della tabella. La funzione es14 legge la
tabella, ne cancella le colonne i cui nomi sono in  insCol e  le righe duplicate,
Salva poi la tabella ottenuta sempre come lista di dizionari nel  file json fileJsonOut.
Restituisce infine il numero di righe nella tabella risultante.

Per caricare e salvare i file json si possono usare load e dump della libreria json.
'''

import json

def es14(fileJsonIn,insCol,fileJsonOut):
    # inserisci qui il tuo codice
    with open(fileJsonIn)as f:
        tabella = json.load(f)
        
    new_tabella = []
    for d in tabella:
        new_tabella.append({chiave:valore for chiave, valore in d.items()if chiave not in insCol})
    final_tabella = []
    for d in new_tabella:
        if d not in final_tabella:
            final_tabella.append(d)
    with open(fileJsonOut, mode= 'w')as f:
        json.dump(final_tabella, f)
    return len(final_tabella)

################################################################################

r'''
    Es 42: 9 punti

    Sia dato un albero di oggetti di tipo Nodo definiti della libreria albero.py allegata,
    con i nodi che contengono valori stringa di almeno 3 caratteri.
    Due figli consecutivi X1 e X2 di un nodo X sono FONDIBILI se il valore X1.id
    termina con gli stessi 3 caratteri con cui inizia il valore X2.id .
    Per fondere due nodi bisogna:
        - sostituire X1.id con la stringa che si ottiene concatenando i due valori
            X1.id e X2.id dopo aver tolto 3 caratteri comuni per evitare la ripetizione
        - aggungere i figli di X2 alla fine della lista dei figli di X1
        - eliminare il nodo X2 dalla lista dei figli di X
    NOTA: Una volta fusi due nodi può succedere che lo X1 risultante sia fondibile con
    con il figlio seguente X3 del nodo X, in tal caso X1 e X3 vanno fusi e così via.

    Esempio, l'albero
         peroncino                             peroncino
        /     |  \                                 |
    tripodi odino inospitale                tripodinospitale
      /     /   \         \                    /       \
    sotto  mani animale   aleatorio         sotto manimaleatorio

    NOTA la fusione va applicata per profondità crescenti a partire dalla radice
    scendendo mano a mano nell'albero.
    In questo modo si potranno riconoscere coppie fondibili, figlie di nodi diversi
    che sono stati fusi in un passaggio precedente
    (come nell'esempio, in cui si sono fusi i tre nodi: mano animale e aleatorio)

    Si scriva la funzione es42(tree), ricorsiva o che fa uso di vostre funzioni ricorsive,
    che riceve un albero come descritto e fonde tutti i nodi fondibili dell'albero, 
    tornando la radice dell'albero risultante.

    NOTA: perchè il test di ricorsione abbia successo la funzione ricorsiva deve essere
    definita a livello globale o essere un metodo di una classe definita a livello globale.
'''

import albero

def es42(tree):
    # inserisci qui il tuo codice
    #calcolo il nodo corrente
    changes = True
    while(changes):
        changes = False
        for i, son in enumerate(tree.f[:-1]):
            #controllo il nodo corrente con il successivo se fondo, break e il ciclo lo rifaccio partire da capo
            if son.id[-3:] == tree.f[i+1].id[:3]:
                new_id = son.id + tree.f[i+1].id[3:]
                son.id = new_id
                son.f += tree.f[i+1].f
                tree.f.remove(tree.f[i+1])
                changes = True
                break
    #sistemati i figli del nodo corrente itero questi e sistemo questi
    for son in tree.f:
        es42(son)
            
    return tree

################################################################################

