################################################################################
################################################################################
################################################################################

''' ATTENZIONE!!! INSERITE QUI SOTTO IL VOSTRO NOME, COGNOME E MATRICOLA '''

nome        = "Manuel"
cognome     = "Arcieri"
matricola   = "1834922"

################################################################################
################################################################################
################################################################################


'''
    Es 2: 5 punti
    Si definisca la funzione es2(tree ) ricorsiva (o che fa uso di funzioni o
    metodi ricorsive/i) che:
    - riceve come argomenti  l'albero 'tree'  formato da nodi di tipo
      Nodo definito nella libreria albero.py allegata
    - torna come risultato il nodo radice dell'albero che si ottiene da tree
    eliminando i suoi nodi foglia con identificatore di valore pari.

    Esempio: con input l'albero in basso a sinistra la funzione deve restituire
    la radice dell'albero in basso a destra

              5                                    5
      ________|_____________               ________|_
     |          |           |             |          |
     20         4           6             20         4
     |     _____|______                           ___|___
     12   |   |  |  |  |                         |   |   |
          10  2  9  8  7                         2   9   7
            __|__
           |     |
           30    22

    NOTA: perchè il test di ricorsione abbia successo la funzione ricorsiva deve essere
    definita a livello globale o essere un metodo di una classe definita a livello globale.
'''
from albero import Nodo


def es2(tree):
    res = leggiFigli(tree)
    return res[0]

def leggiFigli(nodo:Nodo) -> Nodo:
    modifica = False
    for figlio in nodo.f:
        if len(figlio.f) == 0 and figlio.id % 2 == 0:
            nodo.f.remove(figlio)
            modifica = True
            continue
        
        modifica = modifica or leggiFigli(figlio)[1]
    return nodo, modifica if not modifica else leggiFigli(nodo)
            
        
        
        

##########################################################################################


'''
    Es 4: 4 punti
progettare la funzione es4(ftesto) che, preso in input l'indirizzo di un file di
testo ftesto,restituisce la quadrupla (x,y,p1,p2) dove:
- 1) x e' il numero di righe del file di testo
- 2) y il numero di righe del file di testo contenenti un numero dispari di parole
- 3) p1 e' la parola di lungehzza massima tra le parole presenti nel file
     (in caso di parita' di lunghezza massima va considerata quella che precede
     le altre in ordine lessicografico)
- 4) p2 e' la parola che appare piu' volte  tra le parole presenti nel file (in caso
  di parita' di frequenza  massima va considerata quella che precede
  le altre in ordine lessicografico)

Esempio: la funzione sul file di testo ft1.txt deve restituire
la quadrupla (4, 2, 'elefante', 'gatto')
'''

def es4(ftesto):
    # inserisci qui il tuo codice
    return leggiFile(ftesto)

def leggiFile(path:str)->tuple:
    lines=open(path).readlines()
    x=len(lines)
    y=0
    
    p1=[]
    maxP1=0
    
    p2={}
    
    for line in lines:
        parole=line.split()
        if len(parole) % 2 != 0:
            y+=1
        
        for parola in parole:
            if len(parola) > maxP1:
                p1.clear()
                p1.append(parola)
                maxP1 = len(parola)
            elif len(parola) == maxP1:
                p1.append(parola)
                
            frequenza = p2.get(parola, 0)
            p2[parola] = frequenza+1
            
    p1 = list(sorted(p1))[0]
    
    maxFreq=0
    lp2=[]
    for k,v in p2.items():
        if v > maxFreq:
            lp2.clear()
            maxFreq=v
            lp2.append(k)
        elif v==maxFreq:
            lp2.append(k)
            
    p2=list(sorted(lp2))[0]
    
    return x, y, p1, p2
        



###############################################################################################


'''
    Es 7: 5 punti
    Si definisca la funzione es7(pathDir ) ricorsiva (o che fa uso di funzioni o
    metodi ricorsive/i) che:
    - riceve come argomento l'indirizzo di una cartella.
    - restituisce una lista contenente triple. Le triple sono del tipo (S,a,b) dove:
      - S e' il nome di una delle sottocartelle ragiungibili a qualsiasi livello visitando
        l'albero delle cartelle radicato nella cartella.
      - a e'  il  numero totale di file  presenti nella cartella S e nelle sue
        sottocartelle.
      - b e' il numero totale di  sottocartelle  presenti nella cartella
      S e nelle sue sottocartelle.
      Le tuple nella lista devono risultare ordinate in modo decrescente rispetto
      alla somma della seconda e terza componente e a parita' di somma
      in ordine lessicografico crescente rispetto alla prima coordinata.
      ATTENZIONE: File e cartelle il cui nome comincia  col carattere '.'
      non vanno considerati.

      ai fini dello svolgimento dell'esercizio possono risultare utili
      le seguenti funzioni nel modulo os:
      os.listdir(), os.path.isfile(), os.path.isdir(), os.path.basename().

      ATTENZIONE: è PROIBITO usare la funzione os.walk()

    Esempio: con es7('Informatica/Software') viene restituita la lista:
    [('Software', 7, 2), ('SistemiOperativi', 5, 0),('BasiDati', 0, 0)]

    NOTA: perchè il test di ricorsione abbia successo la funzione ricorsiva deve essere
    definita a livello globale o essere un metodo di una classe definita a livello globale.
'''

import os

def es7(pathDir:str):
    Container.dirs = []
    Container.files = []
    
    leggiCartella(pathDir)    
    Container.dirs = list(set(Container.dirs))
    Container.files = list(set(Container.files))
    
    res = []
    d1 = Container.files
    d2 = Container.dirs
    res.append((os.path.basename(pathDir), len(Container.files), len(Container.dirs)))
    
    for d in Container.dirs:
        nfiles = 0
        ndirs = -1
        for f in Container.files:
            if d in f:
                nfiles += 1
        
        for dd in Container.dirs:
            if d in dd:
                ndirs += 1
                
        res.append((os.path.basename(d), nfiles, ndirs))
        
    
    res = list(sorted(res, key = lambda r: r[0]))
    res = list(sorted(res, key = lambda r: r[1] + r[2]))[::-1]
    
    return res


class Container:
    dirs = []
    files = []        
    

def leggiCartella(path: str):
    items = [i for i in os.listdir(path) if not i.startswith('.')]
    files = [os.path.join(path, f) for f in items if os.path.isfile(os.path.join(path, f))]
    dirs = [os.path.join(path, d) for d in items if os.path.isdir(os.path.join(path, d))]
    
    Container.dirs.extend(dirs)
    Container.files.extend(files)
    
    for d in dirs:
        leggiCartella(d)
    
    

###############################################################################################


'''
    Es 13: 5 punti
    Progettare la  funzione es13(fimm,fimm1) che,
    - riceve gli  indirizzi fimm e  fimm1 di due file .PNG.
    - legge l'immagine da fimm ne modifica i colori dei pixel e  la salva poi
      all'indirizzo fimm1.
    - restituisce infine il numero di colori DIFFERENTI presenti nell'immagine modificata.
      Altezza e larghezza della nuova immagine sono le stesse dell'immagine originale.
      I colori dei pixel dalla nuova immagine si ottengono a partire da quelli
      dell'immagine originale applicando la seguente  procedura:
      La griglia dei pixel dell'immagine originale viene partizionata  in sottogriglie
      quadrate ciacuna di dimensione 9 per 9.
      Si puo' assumere che la lunghezza w e l' altezza h dell'immagine sono multipli di 9
      pertanto si avranno h//9 x w//9 sottogriglie.
      Nella nuova immagine il pixel posizionato al
      centro di ciascuna delle sottogriglie conservera' lo stesso colore del pixel
      corrispondente nella foto originaria. Gli altri 80 pixel della sottogriglia
      avranno tutti uno stesso colore.
      Questo colore si ottiene facendo la media intera  dei colori degli 80
      pixel corrispodenti nella foto originaria. Il colore sara' dunque (r,g,b) dove
      -r e' la parte intera della divisione per 80 della  somma
       degli 80 valori del primo canale dei colori degli 80 pixel,
      -g e' la parte intera della divisione per 80 della  somma
       degli 80 valori del secndo canale dei colori deegli 80 pixel,
      -b e' la parte intera della divisione per 80 della  somma
       degli 80 valori del terzo canale dei colori degli 80 pixel,

    Sull'immagine Fig1.png la funzione deve produrre il file RisFig1.png
    e restituire il numero 1379

    Per caricare e salvare i file PNG si possono usare load e save della libreria immagini.
'''

import immagini

def es13(fimm,fimm1):
    # inserisci qui il tuo codice
    immagine = immagini.load(fimm)
    res = immagine[:]
    
    startGrid=[]
    for y in range(0, len(immagine), 9):
        for x in range(0, len(immagine[0]), 9):
            startGrid.append((x, y))
            
    for xstart, ystart in startGrid:
        r = None
        g = None
        b = None
        
        for x in range(0, 9):
            for y in range(0, 9):
                if x == 4 and y == 4:
                    continue
                
                rgb = immagine[y+ystart][x+xstart]
                r = rgb[0] if r is None else r + rgb[0]
                g = rgb[1] if g is None else g + rgb[1]
                b = rgb[2] if b is None else b + rgb[2]
                
        r = r // 80
        g = g // 80
        b = b // 80
        
        for x in range(0, 9):
            for y in range(0, 9):
                if x == 4 and y == 4:
                    continue
                res[y+ystart][x+xstart] = (r,g,b)

    immagini.save(res, fimm1)
    
    
    
    colori = set()
    b = immagini.load(fimm1)
    
    for y in range(0, len(b)):
        for x in range(0, len(b[0])):
            brgb = b[y][x]
            colori.add(brgb)
    
    return len(colori)


 ########################################################################################


'''
    Es 14: 3 punti
    Abbiamo una tabella rappresentata come lista di dizionari    nome_colonna : valore .
    ed una lista contenente i nomi di alcune delle colonne della tabella.
    Vogliamo costruire una nuova tabella  eliminando dalla tabella originaria le colonne i
    cui nomi sono presenti nella lista. Nella nuova tabella in caso di righe uguali
    va conservata solo la prima di queste righe mentre le altre vanno eliminate.
    Si consideri ad esempio la tabella con tre colonne ('nome', 'materia', 'voto')

    | 'nome'  | 'materia'        | 'voto' |
    --------------------------------------
    |'Franco' | 'programmazione' |   30   |
    |'Franco' | 'architettura'   |   30   |
    |'Franco' | 'algoritmi'      |   25   |
    |'Franco' | 'matematica'     |   20   |
    |'Angelo' | 'programmazione' |   30   |
    |'Angelo' | 'architettura'   |   30   |
    |'Angelo' | 'algoritmi'      |   30   |
    |'Lucia'  | 'architettura'   |   30   |
    |'Lucia'  | 'algoritmi'      |   25   |
    |'Lucia'  | 'algebra'        |   18   |
    |'Lucia'  | 'programmazione' |   27   |
    |'Lucia ' | 'matematica'     |   21   |

se la lista coi nomi delle colonne da eliminare contiene 'nome' allora la nuova tabella e':

 | 'materia'        | 'voto' |
 --------------------------------------
 | 'programmazione' |   30   |
 | 'architettura'   |   30   |
 | 'algoritmi'      |   25   |
 | 'matematica'     |   20   |
 | 'algoritmi'      |   30   |
 | 'algebra'        |   18   |
 | 'programmazione' |   27   |
 | 'matematica'     |   21   |


Progettare la  funzione es14(fileJson,insCol,fileJson1) che riceve in input gli  indirizzi
fileJsonIn e  filejsonOut di due file di tipo json ed un  insieme  di stringhe insCol.
Il file fileJsonIn contine una tabella (memorizzata come lista di dizionari) e l'insieme
insCol contiene i nomi di alcune colonne della tabella. La funzione es14 legge la
tabella, ne cancella le colonne i cui nomi sono in  insCol e  le righe duplicate,
Salva poi la tabella ottenuta sempre come lista di dizionari nel  file json fileJsonOut.
Restituisce infine il numero di righe nella tabella risultante.

Per caricare e salvare i file json si possono usare load e dump della libreria json.
'''

import json

def es14(fileJsonIn,insCol,fileJsonOut):
    fin = open(fileJsonIn)
    inJson = json.load(fin)
    fin.close()
    
    res = []
    for e in inJson:
        kk=[]
        vv=[]
        for k,v in e.items():
            if k not in insCol:
                kk.append(k)
                vv.append(v)
                
        diz = {}
        for i in range(len(kk)):
            diz[kk[i]] = vv[i]
        res.append(diz)
        
    chname = set()
    res2=res[::-1]
    for e in res:
        if str(e) in chname:
            res2.remove(e)
        else:
            chname.add(str(e))
            
    fout = open(fileJsonOut, 'w')
    json.dump(res2[::-1], fout)
    fout.close()
    
    return len(res2)
    
    

################################################################################

r'''
    Es 42: 9 punti

    Sia dato un albero di oggetti di tipo Nodo definiti della libreria albero.py allegata,
    con i nodi che contengono valori stringa di almeno 3 caratteri.
    Due figli consecutivi X1 e X2 di un nodo X sono FONDIBILI se il valore X1.id
    termina con gli stessi 3 caratteri con cui inizia il valore X2.id .
    Per fondere due nodi bisogna:
        - sostituire X1.id con la stringa che si ottiene concatenando i due valori
            X1.id e X2.id dopo aver tolto 3 caratteri comuni per evitare la ripetizione
        - aggungere i figli di X2 alla fine della lista dei figli di X1
        - eliminare il nodo X2 dalla lista dei figli di X
    NOTA: Una volta fusi due nodi può succedere che lo X1 risultante sia fondibile con
    con il figlio seguente X3 del nodo X, in tal caso X1 e X3 vanno fusi e così via.

    Esempio, l'albero
         peroncino                             peroncino
        /     |  \                                 |
    tripodi odino inospitale                tripodinospitale
      /     /   \         \                    /       \
    sotto  mani animale   aleatorio         sotto manimaleatorio

    NOTA la fusione va applicata per profondità crescenti a partire dalla radice
    scendendo mano a mano nell'albero.
    In questo modo si potranno riconoscere coppie fondibili, figlie di nodi diversi
    che sono stati fusi in un passaggio precedente
    (come nell'esempio, in cui si sono fusi i tre nodi: mano animale e aleatorio)

    Si scriva la funzione es42(tree), ricorsiva o che fa uso di vostre funzioni ricorsive,
    che riceve un albero come descritto e fonde tutti i nodi fondibili dell'albero, 
    tornando la radice dell'albero risultante.

    NOTA: perchè il test di ricorsione abbia successo la funzione ricorsiva deve essere
    definita a livello globale o essere un metodo di una classe definita a livello globale.
'''

def es42(tree):  # <3
    return scorriAlbero(tree)

def scorriAlbero(nodo: Nodo, going = False) -> Nodo:
    for i in range(0, len(nodo.f) - 1):
        x1 = nodo.f[i]
        x2 = nodo.f[i + 1]
        
        if x1.id.endswith(x2.id[:3]):
            going = True
            newid = x1.id + x2.id[3:]
            x1.f.extend(x2.f)
            newf = x1.f
            
            nodo.f[i] = Nodo(newid)
            nodo.f[i].f = newf
            del nodo.f[i + 1]
            break
        
    if going:
        return scorriAlbero(nodo)
    else:
        for i in range(len(nodo.f)):
            nuovoNodo = scorriAlbero(nodo.f[i])
            nodo.f[i] = nuovoNodo
    return nodo
            
            

################################################################################

