
from testlib import check, runtests, check_text_file, check_img_file, check_json_file
import isrecursive

import albero

import program1

###############################################################################
def test_nome_cognome_matricola():
    assert program1.nome        != 'NOME',      "ATTENZIONE, NON HAI INSERITO IL TUO NOME NEL FILE program.py !!!"
    assert program1.cognome     != 'COGNOME',   "ATTENZIONE, NON HAI INSERITO IL TUO COGNOME NEL FILE program.py !!!"
    assert program1.matricola   != 'MATRICOLA', "ATTENZIONE, NON HAI INSERITO LA TUA MATRICOLA NEL FILE program.py !!!"
    return 0

###############################################################################


def test_es2a(lista,  expected):
    tree1   = albero.fromLista(lista)
    try:
        isrecursive.decorate_module(program1)
        program1.es2(tree1)
    except isrecursive.RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        isrecursive.undecorate_module(program1)
    tree1   = albero.fromLista(lista)
    ris= program1.es2(tree1)
    check(type(ris),type(albero.Nodo(1)),None," bisogna restituire un oggetto di tipo Nodo")
    listaRis=albero.toLista(ris)
    check(listaRis,expected,None,"il valore restituito non e' corretto")
    return 1


def test_es2a_1():
    '''\nPrimo test della funzione es2 con tree uguale all'albero in basso a sinistra

               5
      ________|_____________
     |          |           |
     20         4           6
     |     _____|______
     11   |   |  |  |  |
          10  2  9  8  7
            __|__
           |     |
           3     1

    '''
    lista1= [5, [[20, [[12, []]]], [4, [[10, []], [2, [[30, []], [22, []]]],
    [9, []], [8, []],[7, []]]],[6, []]]]
    lista1b1=[5, [[20, []], [4, [[2, []], [9, []], [7, []]]]]]
    return test_es2a(lista1,lista1b1)

def test_es2a_2():
    '''\nSecondo test della funzione es2 con tree uguale all'albero in basso a sinistra

                  7
           _______|______
          |              |
          5              9
       ___|___        ___|__
      |       |      |      |
      10      8      3      1
     _|_     _|_    _|_    _|_
    |   |   |   |  |   |  |   |
    1   2   12  13 15  6  4   0


    '''
    lista2=[7,[[5,[[10,[[1,[]],[2,[]]]],[8,[[12,[]],[13,[]]]]]],[9,[[3,[[15,[]],[6,[]]]],
    [1,[[4,[]],[0,[]]]]]]]]
    lista2b1=[7, [[5, [[10, [[1, []]]], [8, [[13, []]]]]], [9, [[3, [[15, []]]], [1, []]]]]]
    return 2 if test_es2a(lista2,lista2b1) else 0

def test_es2a_3():
    '''\nTerzo test della funzione es2 con tree uguale all'albero in basso a sinistra

                          76
            ______________|_______________
           |                              |
          12                              37
    _______|_______              _________|_____
   |               |            |      |        |
   15             80           71     39        100
 __|__          ___|____     __|__            __|___
|     |         |       |   |     |          |      |
5     19        47      96  92   67         23      121
   ___|___    __|___         ____|______     |      |
  |       |  |      |       |     |     |    |      |
  181     28 94     29      70    83    8   81     44
                                        |
                                       30
                                       _|_
                                      |   |
                                     46  21
    '''
    lista3= [76, [[12, [[15, [[5, []], [19, [[181, []], [28, []]]]]],
    [80, [[47, [[94, []], [29, []]]],[96, []]]]]], [37, [[71, [[92, []],
    [67, [[70, []], [83, []], [8, [[30, [[46, []], [21, []]]]]]]]]],
    [39, []], [100, [[23, [[81, []]]], [121, [[44, []]]]]]]]]]
    lista3b1=[76, [[12, [[15, [[5, []], [19, [[181, []]]]]], [80, [[47,
    [[29, []]]]]]]], [37, [[71, [[67, [[83, []], [8, [[30, [[21, []]]]]]]]]],
    [39, []], [100, [[23, [[81, []]]], [121, []]]]]]]]
    return 2 if test_es2a(lista3,lista3b1) else 0

################################################################################


def test_es4a_1():
    ''' \nPrimo test della funzione es4 sul file ft1.txt'''
    ris = program1.es4('ft1.txt')
    check(type(ris),tuple,None," bisogna restituire una tupla")
    check(ris, (4, 2, 'elefante', 'gatto'), None, " la risposta non e' corretta")
    return 1

def test_es4a_2():
    ''' \nSecondo test della funzione es4 sul file ft2.txt'''
    ris = program1.es4('ft2.txt')
    check(type(ris),tuple,None," bisogna restituire una tupla")
    check(ris, (20, 12, 'a', 'm'), None, " la risposta non e' corretta")
    return 1

def test_es4a_3():
    ''' \nTerzo test della funzione es4 sul file ft3.txt'''
    ris = program1.es4('ft3.txt')
    check(type(ris),tuple,None," bisogna restituire una tupla")
    check(ris, (6, 4, 'lampada', 'cane'), None, " la risposta non e' corretta")
    return 1

def test_es4a_4():
    ''' \nTerzo test della funzione es4 sul file ft9.txt'''
    ris = program1.es4('ft9.txt')
    check(type(ris),tuple,None," bisogna restituire una tupla")
    check(ris, (21, 20, 'lampada', 'amo'), None, " la risposta non e' corretta")
    return 1


###############################################################################


def test_es5a_1():
    ''' \nPrimo test della funzione es5 con
    lista= ['amare', 'cannone', 'cantare', 'dormire',  'gommone', 'torrone',
            'burrone', 'partire', 'estate', 'morire', 'fiorire']
    '''
    lista1= ['amare', 'cannone', 'cantare', 'dormire',  'gommone', 'torrone', 'burrone',
    'partire','estate','morire', 'fiorire']
    d1={'are': ['cantare', 'amare'], 'one': ['burrone', 'cannone', 'gommone', 'torrone'],
    'ire': ['dormire', 'fiorire', 'partire', 'morire'], 'ate': ['estate']}
    ris = program1.es5(lista1)
    check(type(ris),dict,None," bisogna restituire un dizionario")
    check(ris, d1, None, " la risposta non e' corretta")
    return 1

def test_es5a_2():
    ''' \nSecondo test della funzione es5 con
    lista=['cono', 'cattivo', 'vino', 'prato', 'lato',
           'camino', 'cammino', 'fiato', 'buono', 'ulivo']
    '''
    lista2=['cono', 'cattivo', 'vino', 'prato', 'lato',
    'camino', 'cammino', 'fiato', 'buono', 'ulivo']
    d2={'ono': ['buono', 'cono'],
        'ivo': ['cattivo', 'ulivo'],
        'ino': ['cammino', 'camino', 'vino'],
        'ato': ['fiato', 'prato', 'lato']}
    ris = program1.es5(lista2)
    check(type(ris),dict,None," bisogna restituire un dizionario")
    check(ris, d2, None, " la risposta non e' corretta")
    return 1

def test_es5a_3():
    ''' \nTerzo test della funzione es5 con
    lista3=[ 'aaa', 'xxy', 'aaaa', 'axxy', 'sst',
             'baaa', 'ccaaa', 'zxxxy', 'xxxy', 'zsst']
    '''
    lista3=[ 'aaa','xxy','aaaa','axxy','sst','baaa', 'ccaaa','zxxxy','xxxy', 'zsst']
    ris = program1.es5(lista3)
    d3={'aaa': ['ccaaa', 'aaaa', 'baaa', 'aaa'],
        'xxy': ['zxxxy', 'axxy', 'xxxy', 'xxy'],
        'sst': ['zsst', 'sst']}
    check(type(ris),dict,None," bisogna restituire un dizionario")
    check(ris, d3, None, " la risposta non e' corretta")
    return 1



################################################################################

def test_es7a(cartella,  expected):
    try:
        isrecursive.decorate_module(program1)
        program1.es7(cartella)
    except isrecursive.RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        isrecursive.undecorate_module(program1)
    ris = program1.es7(cartella)
    check(type(ris),list ,None," bisogna restituire una lista")
    check(ris, expected, None, " la risposta non e' corretta")
    return 1

def test_es7a_1():
    ''' \nPrimo test della funzione es7 sulla cartella 'Informatica/Software' '''
    lista1b=[('Software', 7, 2), ('SistemiOperativi', 5, 0), ('BasiDati', 0, 0)]
    return test_es7a('Informatica/Software',  lista1b)

def test_es7a_2():
    ''' \nSecondo test della funzione es7 sulla cartella 'Informatica/Hardware' '''
    lista2b= [('Hardware', 5, 3), ('Architetture', 5, 2), ('Processori', 2, 1), ('RISC', 2, 0)]
    return 2 if test_es7a('Informatica/Hardware',  lista2b) else 0

def test_es7a_3():
    ''' \nTerzo test della funzione es7 sulla cartella 'Informatica' '''
    lista3b=[('Informatica', 14, 7), ('Software', 7, 2), ('Hardware', 5, 3),
    ('Architetture', 5, 2), ('SistemiOperativi', 5, 0), ('Processori', 2, 1),
    ('RISC', 2, 0), ('BasiDati', 0, 0)]
    return 2 if test_es7a('Informatica',  lista3b) else 0

################################################################################

def test_es8a_1():
    ''' \nPrimo test della funzione es8 con liste:
    lista1=['caso','melo','puri','pero','rana']
    lista2=['velo','volo','viso', 'vaso', 'dado','dito']
     '''
    l1=['caso','melo','puri','pero','rana']
    l1b=['velo','volo','viso', 'vaso', 'dado','dito']
    ris = program1.es8(l1,l1b)
    check(type(ris),dict ,None," bisogna restituire un dizionario")
    d1={'caso': 'vaso', 'melo': 'velo', 'puri': 'dado', 'pero': 'velo', 'rana': 'dado'}
    check(ris, d1, None, " la risposta non e' corretta")
    return 1

def test_es8a_2():
    ''' \nSecondo test della funzione es8 con liste
    lista1=['carbone', 'canotto', sultani', 'caviale', 'bacillo', 'palmare']
    lista2=['declino', 'granito', 'sovrani', 'castano', 'criceto', 'polenta']
     '''
    l2=['carbone', 'canotto', 'sultani', 'caviale', 'bacillo', 'palmare']
    l2b=['declino', 'granito', 'sovrani', 'castano', 'criceto', 'polenta']
    ris = program1.es8(l2,l2b)
    d2={'carbone': 'castano', 'canotto': 'castano', 'sultani': 'sovrani',
    'caviale': 'castano', 'bacillo': 'castano', 'palmare': 'castano'}
    check(type(ris),dict,None," bisogna restituire un dizionario")
    check(ris, d2, None, " la risposta non e' corretta")
    return 1

def test_es8a_3():
    ''' \nTerzo test della funzione es8 con liste
    lista1=['zvutsr','abcdef', fedcba','fghilm','mlihgf','rstuvz']
    lista2=['hbhdhf', 'gbgdgf','federa', 'fghilm', 'alihaa']
    '''
    l3=['zvutsr','abcdef', 'fedcba','fghilm','mlihgf','rstuvz']
    l3b=['hbhdhf', 'gbgdgf','federa', 'fghilm', 'alihaa']
    ris = program1.es8(l3,l3b)
    d3={'zvutsr': 'alihaa', 'abcdef': 'gbgdgf',
    'fedcba': 'federa', 'fghilm': 'fghilm', 'mlihgf': 'alihaa',
    'rstuvz': 'alihaa'}
    check(type(ris),dict,None," bisogna restituire un dizionario")
    check(ris, d3, None, " la risposta non e' corretta")
    return 1


################################################################################

def test_es13a_1():
    ''' \nPrimo  test della funzione es13 dove  viene passata
    l'immagine Foto1.png e creata l'immagine testFoto1.png
    che deve corrispondere a quella in RisFoto1.png'''
    returned = program1.es13('Foto1.png','testFoto1.png')
    check(returned, 1379, None, "il valore restituito non e' corretto")
    check_img_file('testFoto1.png', 'RisFoto1.png')
    return 1

def test_es13a_2():
    ''' \nSecondo test della funzione es13 dove viene passata
    l'immagine Foto2.png e creata l'immagine testFoto2.png
    che deve corrispondere a quella in RisFoto2.png'''
    returned = program1.es13('Foto2.png','testFoto2.png')
    check(returned, 231, None, "il valore restituito non e' corretto")
    check_img_file('testFoto2.png', 'RisFoto2.png')
    return 2

def test_es13a_3():
    ''' \nTerzo test della funzione es13 dove viene passata
    l'immagine Foto3.png e creata l'immagine testFoto3.png
    che deve corrispondere a quella in RisFoto3.png'''
    returned = program1.es13('Foto3.png','testFoto3.png')
    check(returned, 606, None, "il valore restituito non e' corretto")
    check_img_file('testFoto3.png', 'RisFoto3.png')
    return 2

    ##########################################################

def test_es14a_1():
    ''' \nPrimo  test della funzione es14 dove  viene passata
    la tabella nel file Tabella.json, cancellata la colonna 'nome'
    e creata la tabella nel file testTab1.json che deve corrispondere
    a quella in RisTab1.json'''
    returned = program1.es14('tabella.json',{'nome'},'testTab1.json')
    check(returned, 8, None, "il valore restituito non e' corretto")
    #with open('testTab1.json') as f1: tabProd = json.load(f1)
    #with open('RisTab1.json') as f2:  tabExp = json.load(f2)
    #check(tabProd, tabExp, None, "la tabella costruita non e' corretta")
    check_json_file('testTab1.json', 'RisTab1.json')
    return 1

def test_es14a_2():
    ''' \nSecondo test della funzione es14 dove  viene passata
    la tabella nel file Tabella.json, cancellata la colonna 'materia'
    e creata la tabella nel file testTab2.json che deve corrispondere
    a quella in RisTab2.json'''
    returned = program1.es14('tabella.json',{'materia'},'testTab2.json')
    check(returned, 8, None, "il valore restituito non e' corretto")
    check_json_file('testTab2.json', 'RisTab2.json')
    return 1

def test_es14a_3():
    ''' \nTerzo test della funzione es14 dove  viene passata
    la tabella nel file Tabella.json, cancellate le colonne
    'materia' e 'voto'  e creata la tabella nel file testTab3.json
    che deve corrispondere a quella in RisTab3.json'''
    returned = program1.es14('tabella.json',{'materia','voto'},'testTab3.json')
    check(returned, 3, None, "il valore restituito non e' corretto")
    check_json_file('testTab3.json', 'RisTab3.json')
    return 1

################################################################################
def test_es42(lista, expected):
    tree   = albero.fromLista(lista)
    try:
        isrecursive.decorate_module(program1)
        program1.es42(tree)
    except isrecursive.RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        isrecursive.undecorate_module(program1)
    tree = albero.fromLista(lista)
    ris = program1.es42(tree)
    check( type(ris), albero.Nodo, None, "il risultato non è un Nodo")
    lista2 = albero.toLista(ris)
    check( lista2, expected, None, "il risultato non è l'albero corretto")
    return 3

def test_es42_1():
    lista = [ 'peroncino', [    ['tripodi',     [['sotto', []]]],
                                ['odino',       [['mani', []],
                                                 ['animale', []]]],
                                ['inospitale',  [[ 'aleatorio', [] ]]]]]
    expected = [ 'peroncino', [[ 'tripodinospitale' , [ ['sotto', []],
                                                        ['manimaleatorio', []]]]]]
    return test_es42(lista, expected)

def test_es42_2():
    lista = ['mucchio', [
            ['dimentican',[]], ['cane',[
                    ['pila',[]], ['ilare',[]], ['arene',[]], ['energia',[]], ['giara',[]], ['aratro',[]], ['dottor',[]], ['tordo',[]]
                                        ]], ['anelito',[
                                                ['secchio',[]],['chiodo',[
                                                        ['pero',[]], ['eroe',[]]
                                                                            ]],['odore',[]]
                                                        ]], ['vomito',[
                                                                ['coro',[
                                                                        ['mina',[]],['semina',[]]
                                                                        ]],['toro',[]]
                                                                        ]]
                            ]
        ]
    expected = ['mucchio', [['dimenticanelito', [['pilarenergiaratro', []], ['dottordo', []], ['secchio', []], ['chiodore', [['peroe', []]]]]], ['vomito', [['coro', [['mina', []], ['semina', []]]], ['toro', []]]]]]
    return test_es42(lista, expected)

def test_es42_3():
    lista = ['testa', [
            ['suono',[]],['onorevole',[]],['volente',
            [['pino',[
                    ['affare',[]]
                    ]],['inoculato',[
                            ['area',[]]
                            ]],['biro',[]]]],
                                        ['coro',[
                                                ['sodo',[]]
                                                ]
                                        ],
                                        ['orologio',[
                                                    ['dolore',[]],
                                                    ['oreficeria',[]]
                                                    ]
                                        ],
                                        ['giochi',[]],
                                        ['chimera',[
                                                   ['rianimazione',[]],
                                                   ['onesto',[
                                                             ['cruccio',[]]
                                                             ]
                                                   ],
                                                   ['storico',[
                                                              ['ciottolo',[]]
                                                              ]
                                                   ]
                                                   ]
                                        ]
            ]
        ]
    expected = ['testa', [['suonorevole', []], ['volente', [['pinoculato', [['affarea', []]]], ['biro', []]]], ['corologiochimera', [['sodo', []], ['doloreficerianimazionestorico', [['crucciottolo', []]]]]]]]
    return test_es42(lista, expected)

################################################################################


tests = [
    test_nome_cognome_matricola,
    test_es2a_1, test_es2a_2, test_es2a_3,
    test_es4a_1, test_es4a_2, test_es4a_3, test_es4a_4,
    #test_es5a_1, test_es5a_2, test_es5a_3,
    test_es7a_1, test_es7a_2, test_es7a_3,
    #test_es8a_1, test_es8a_2, test_es8a_3,
    test_es13a_1, test_es13a_2, test_es13a_3,
    test_es14a_1, test_es14a_2, test_es14a_3,
    test_es42_1, test_es42_2,test_es42_3,
]

if __name__ == '__main__':
    # runtests(tests)
    runtests(tests, logfile='grade.csv')

################################################################################


